//! Socket handlers
use super::*;

use tokio::io::{
    AsyncWrite,
    AsyncRead
};
use tokio::task::JoinHandle;
use futures::Future;
use cancel::*;



/// Handles a raw, opened socket
pub fn handle_socket_with_shutdown<R, W, C: cancel::CancelFuture + 'static + Send>(tx: W, rx: R, shutdown: C) -> JoinHandle<eyre::Result<()>>
where R: AsyncRead + Unpin + Send + 'static,
      W: AsyncWrite + Unpin + Send + 'static
{
    tokio::spawn(async move {
	match {
	    with_cancel!(async move {
		//TODO: How to handle reads+writes?
		Ok(())
	    }, shutdown)
	} {
	    Ok(v) => v,
	    Err(x) => Err(eyre::Report::from(x)),
	}
    })
}
